"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ToggleSlider_exports = {};
__export(ToggleSlider_exports, {
  ToggleSlider: () => ToggleSlider
});
module.exports = __toCommonJS(ToggleSlider_exports);
var import_jkl_react_hooks = require("@fremtind/jkl-react-hooks");
var import_classnames = __toESM(require("classnames"));
var import_react = __toESM(require("react"));
var import_usePillStyles = require("./usePillStyles");
const ToggleSlider = (_a) => {
  var _b = _a, {
    children,
    labels,
    className = "",
    onToggle,
    defaultValue,
    hideLegend = false,
    density
  } = _b, rest = __objRest(_b, [
    "children",
    "labels",
    "className",
    "onToggle",
    "defaultValue",
    "hideLegend",
    "density"
  ]);
  const [currentLabel, setCurrentLabel] = (0, import_react.useState)(defaultValue || labels[0]);
  const id = (0, import_jkl_react_hooks.useId)("jkl-toggle-slider");
  const legendId = (0, import_jkl_react_hooks.useId)("jkl-toggle-slider-legend");
  const activeRef = (0, import_react.useRef)(null);
  const shouldTransform = currentLabel === labels[1];
  const pillStyles = (0, import_usePillStyles.usePillStyles)(activeRef, shouldTransform, [density]);
  const handleChange = (_, pressed) => {
    setCurrentLabel(pressed ? labels[1] : labels[0]);
    onToggle(pressed ? labels[1] : labels[0]);
  };
  const handleClick = (event) => {
    const { value } = event.currentTarget;
    setCurrentLabel(value);
    onToggle(value);
  };
  const { gestureHandlers } = (0, import_jkl_react_hooks.useSwipeGesture)({
    onClick: handleClick,
    onChange: handleChange
  });
  const _a2 = gestureHandlers, { onClick } = _a2, swipeHandlers = __objRest(_a2, ["onClick"]);
  if (true) {
    console.error(
      "WARNING: ToggleSlider component has been deprecated and will be removed in some future version of the library"
    );
  }
  return /* @__PURE__ */ import_react.default.createElement(
    "fieldset",
    __spreadProps(__spreadValues({}, rest), {
      className: (0, import_classnames.default)("jkl-toggle-slider", className),
      "aria-labelledby": legendId,
      "data-testid": "jkl-toggle-slider",
      "data-density": density
    }),
    /* @__PURE__ */ import_react.default.createElement(
      "div",
      {
        id: legendId,
        className: (0, import_classnames.default)("jkl-toggle-slider__legend", {
          "jkl-toggle-slider__legend--sr-only": hideLegend
        })
      },
      children
    ),
    /* @__PURE__ */ import_react.default.createElement("div", __spreadValues({ className: "jkl-toggle-slider__inputs" }, swipeHandlers), labels.map((label) => /* @__PURE__ */ import_react.default.createElement(import_react.Fragment, { key: label }, /* @__PURE__ */ import_react.default.createElement(
      "input",
      {
        className: "jkl-toggle-slider__input",
        type: "radio",
        value: label,
        checked: label === currentLabel,
        name: id,
        id: "".concat(label, "-").concat(id),
        onClick,
        onChange: () => {
        }
      }
    ), /* @__PURE__ */ import_react.default.createElement(
      "label",
      {
        className: (0, import_classnames.default)("jkl-toggle-slider__label", {
          "jkl-toggle-slider__label--selected": label === currentLabel
        }),
        ref: label === currentLabel ? activeRef : void 0,
        htmlFor: "".concat(label, "-").concat(id)
      },
      label
    ))), /* @__PURE__ */ import_react.default.createElement(
      "span",
      {
        className: "jkl-toggle-slider__pill",
        style: pillStyles,
        "aria-hidden": true
      }
    ))
  );
};
//# sourceMappingURL=ToggleSlider.js.map
