"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ToggleSwitch_exports = {};
__export(ToggleSwitch_exports, {
  ToggleSwitch: () => ToggleSwitch
});
module.exports = __toCommonJS(ToggleSwitch_exports);
var import_jkl_icons_react = require("@fremtind/jkl-icons-react");
var import_jkl_react_hooks = require("@fremtind/jkl-react-hooks");
var import_classnames = __toESM(require("classnames"));
var import_react = __toESM(require("react"));
const ToggleSwitch = (0, import_react.forwardRef)(
  (_a, ref) => {
    var _b = _a, {
      "aria-pressed": ariaPressed = false,
      children,
      className,
      density,
      id,
      onChange
    } = _b, rest = __objRest(_b, [
      "aria-pressed",
      "children",
      "className",
      "density",
      "id",
      "onChange"
    ]);
    const uid = (0, import_jkl_react_hooks.useId)(id || "jkl-toggle-switch", { generateSuffix: !id });
    const [pressed, setPressed] = import_react.default.useState(ariaPressed);
    import_react.default.useEffect(() => {
      setPressed(ariaPressed);
    }, [ariaPressed]);
    const _a2 = rest, {
      onClick,
      onPointerCancel,
      onPointerDown,
      onPointerMove,
      onPointerUp
    } = _a2, buttonProps = __objRest(_a2, [
      "onClick",
      "onPointerCancel",
      "onPointerDown",
      "onPointerMove",
      "onPointerUp"
    ]);
    const handleClick = (event) => {
      setPressed(!pressed);
      onChange == null ? void 0 : onChange(event, !pressed);
      onClick == null ? void 0 : onClick(event);
    };
    const handleChange = (event, toggleTo) => {
      if (toggleTo !== pressed) {
        setPressed(toggleTo);
        onChange == null ? void 0 : onChange(event, toggleTo);
      }
    };
    const { gestureHandlers } = (0, import_jkl_react_hooks.useSwipeGesture)({
      onClick: handleClick,
      onChange: handleChange,
      onPointerCancel,
      onPointerDown,
      onPointerMove,
      onPointerUp
    });
    return /* @__PURE__ */ import_react.default.createElement(
      "button",
      __spreadValues(__spreadValues({
        className: (0, import_classnames.default)("jkl-toggle-switch", className),
        id: uid,
        ref,
        "aria-pressed": pressed,
        "data-density": density
      }, buttonProps), buttonProps.disabled ? {} : gestureHandlers),
      children,
      /* @__PURE__ */ import_react.default.createElement("div", { "aria-hidden": true, className: "jkl-toggle-switch-widget" }, /* @__PURE__ */ import_react.default.createElement("div", { className: "jkl-toggle-switch-widget__slider" }, /* @__PURE__ */ import_react.default.createElement("div", { className: "jkl-toggle-switch-widget__knob" }), /* @__PURE__ */ import_react.default.createElement(
        import_jkl_icons_react.CheckIcon,
        {
          variant: "small",
          bold: true,
          className: "jkl-toggle-switch-widget__indicator"
        }
      )))
    );
  }
);
ToggleSwitch.displayName = "ToggleSwitch";
//# sourceMappingURL=ToggleSwitch.js.map
