"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var usePillStyles_exports = {};
__export(usePillStyles_exports, {
  usePillStyles: () => usePillStyles
});
module.exports = __toCommonJS(usePillStyles_exports);
var import_react = require("react");
function throttle(fn) {
  let wait = false;
  return (...args) => {
    if (wait)
      return void 0;
    const result = fn(...args);
    wait = true;
    window.setTimeout(() => {
      wait = false;
    }, 200);
    return result;
  };
}
const usePillStyles = (ref, shouldTransform, dependencies) => {
  const [width, setWidth] = (0, import_react.useState)(0);
  const [distance, setDistance] = (0, import_react.useState)(0);
  const setStyles = (0, import_react.useCallback)(() => {
    if (ref.current && ref.current.parentElement) {
      setWidth(ref.current.clientWidth);
      const translateDistance = shouldTransform ? ref.current.parentElement.clientWidth - ref.current.clientWidth : 0;
      setDistance(translateDistance);
    }
  }, [ref, shouldTransform, ...dependencies]);
  const throttledSetStyles = (0, import_react.useMemo)(() => throttle(setStyles), [setStyles]);
  (0, import_react.useEffect)(() => {
    setStyles();
    typeof window !== "undefined" && window.addEventListener("resize", throttledSetStyles);
    return () => {
      typeof window !== "undefined" && window.removeEventListener("resize", throttledSetStyles);
    };
  }, [setStyles, throttledSetStyles]);
  return {
    width,
    transform: "translateX(".concat(distance, "px)")
  };
};
//# sourceMappingURL=usePillStyles.js.map
