var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { useId, useSwipeGesture } from "@fremtind/jkl-react-hooks";
import cn from "classnames";
import React, {
  useState,
  Fragment,
  useRef
} from "react";
import { usePillStyles } from "./usePillStyles";
const ToggleSlider = (_a) => {
  var _b = _a, {
    children,
    labels,
    className = "",
    onToggle,
    defaultValue,
    hideLegend = false,
    density
  } = _b, rest = __objRest(_b, [
    "children",
    "labels",
    "className",
    "onToggle",
    "defaultValue",
    "hideLegend",
    "density"
  ]);
  const [currentLabel, setCurrentLabel] = useState(defaultValue || labels[0]);
  const id = useId("jkl-toggle-slider");
  const legendId = useId("jkl-toggle-slider-legend");
  const activeRef = useRef(null);
  const shouldTransform = currentLabel === labels[1];
  const pillStyles = usePillStyles(activeRef, shouldTransform, [density]);
  const handleChange = (_, pressed) => {
    setCurrentLabel(pressed ? labels[1] : labels[0]);
    onToggle(pressed ? labels[1] : labels[0]);
  };
  const handleClick = (event) => {
    const { value } = event.currentTarget;
    setCurrentLabel(value);
    onToggle(value);
  };
  const { gestureHandlers } = useSwipeGesture({
    onClick: handleClick,
    onChange: handleChange
  });
  const _a2 = gestureHandlers, { onClick } = _a2, swipeHandlers = __objRest(_a2, ["onClick"]);
  if (true) {
    console.error(
      "WARNING: ToggleSlider component has been deprecated and will be removed in some future version of the library"
    );
  }
  return /* @__PURE__ */ React.createElement(
    "fieldset",
    __spreadProps(__spreadValues({}, rest), {
      className: cn("jkl-toggle-slider", className),
      "aria-labelledby": legendId,
      "data-testid": "jkl-toggle-slider",
      "data-density": density
    }),
    /* @__PURE__ */ React.createElement(
      "div",
      {
        id: legendId,
        className: cn("jkl-toggle-slider__legend", {
          "jkl-toggle-slider__legend--sr-only": hideLegend
        })
      },
      children
    ),
    /* @__PURE__ */ React.createElement("div", __spreadValues({ className: "jkl-toggle-slider__inputs" }, swipeHandlers), labels.map((label) => /* @__PURE__ */ React.createElement(Fragment, { key: label }, /* @__PURE__ */ React.createElement(
      "input",
      {
        className: "jkl-toggle-slider__input",
        type: "radio",
        value: label,
        checked: label === currentLabel,
        name: id,
        id: "".concat(label, "-").concat(id),
        onClick,
        onChange: () => {
        }
      }
    ), /* @__PURE__ */ React.createElement(
      "label",
      {
        className: cn("jkl-toggle-slider__label", {
          "jkl-toggle-slider__label--selected": label === currentLabel
        }),
        ref: label === currentLabel ? activeRef : void 0,
        htmlFor: "".concat(label, "-").concat(id)
      },
      label
    ))), /* @__PURE__ */ React.createElement(
      "span",
      {
        className: "jkl-toggle-slider__pill",
        style: pillStyles,
        "aria-hidden": true
      }
    ))
  );
};
export {
  ToggleSlider
};
//# sourceMappingURL=ToggleSlider.js.map
