var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { CheckIcon } from "@fremtind/jkl-icons-react";
import {
  useId,
  useSwipeGesture
} from "@fremtind/jkl-react-hooks";
import cn from "classnames";
import React, {
  forwardRef
} from "react";
const ToggleSwitch = forwardRef(
  (_a, ref) => {
    var _b = _a, {
      "aria-pressed": ariaPressed = false,
      children,
      className,
      density,
      id,
      onChange
    } = _b, rest = __objRest(_b, [
      "aria-pressed",
      "children",
      "className",
      "density",
      "id",
      "onChange"
    ]);
    const uid = useId(id || "jkl-toggle-switch", { generateSuffix: !id });
    const [pressed, setPressed] = React.useState(ariaPressed);
    React.useEffect(() => {
      setPressed(ariaPressed);
    }, [ariaPressed]);
    const _a2 = rest, {
      onClick,
      onPointerCancel,
      onPointerDown,
      onPointerMove,
      onPointerUp
    } = _a2, buttonProps = __objRest(_a2, [
      "onClick",
      "onPointerCancel",
      "onPointerDown",
      "onPointerMove",
      "onPointerUp"
    ]);
    const handleClick = (event) => {
      setPressed(!pressed);
      onChange == null ? void 0 : onChange(event, !pressed);
      onClick == null ? void 0 : onClick(event);
    };
    const handleChange = (event, toggleTo) => {
      if (toggleTo !== pressed) {
        setPressed(toggleTo);
        onChange == null ? void 0 : onChange(event, toggleTo);
      }
    };
    const { gestureHandlers } = useSwipeGesture({
      onClick: handleClick,
      onChange: handleChange,
      onPointerCancel,
      onPointerDown,
      onPointerMove,
      onPointerUp
    });
    return /* @__PURE__ */ React.createElement(
      "button",
      __spreadValues(__spreadValues({
        className: cn("jkl-toggle-switch", className),
        id: uid,
        ref,
        "aria-pressed": pressed,
        "data-density": density
      }, buttonProps), buttonProps.disabled ? {} : gestureHandlers),
      children,
      /* @__PURE__ */ React.createElement("div", { "aria-hidden": true, className: "jkl-toggle-switch-widget" }, /* @__PURE__ */ React.createElement("div", { className: "jkl-toggle-switch-widget__slider" }, /* @__PURE__ */ React.createElement("div", { className: "jkl-toggle-switch-widget__knob" }), /* @__PURE__ */ React.createElement(
        CheckIcon,
        {
          variant: "small",
          bold: true,
          className: "jkl-toggle-switch-widget__indicator"
        }
      )))
    );
  }
);
ToggleSwitch.displayName = "ToggleSwitch";
export {
  ToggleSwitch
};
//# sourceMappingURL=ToggleSwitch.js.map
